void Decode_AMD(void);

/* AMD-specific information */
void Decode_AMD(void)
{
    FILE *logfile=0;
    int maxi;
    unsigned int eax,ebx,ecx,edx,dummy;
    int stepping,model,family,reserved;

    cpuid(0x80000000, &eax, &dummy, &dummy, &dummy);    /* eax == Max number of inputs for CPUID. */

    if (eax >= 0x80000004) {

	if (open_log_file(&logfile)==TRUE) {
	    fprintf(logfile, "\tProcessor: ");

	    cpuid (0x80000002, &eax, &ebx, &ecx, &edx);
	    regprint(logfile, eax);
	    regprint(logfile, ebx);
	    regprint(logfile, ecx);
	    regprint(logfile, edx);

	    cpuid (0x80000003, &eax, &ebx, &ecx, &edx);
	    regprint(logfile, eax);
	    regprint(logfile, ebx);
	    regprint(logfile, ecx);
	    regprint(logfile, edx);

	    cpuid (0x80000004, &eax, &ebx, &ecx, &edx);
	    regprint(logfile, eax);
	    regprint(logfile, ebx);
	    regprint(logfile, ecx);
	    regprint(logfile, edx);

	    fprintf(logfile, "\n");
	    close_log_file(&logfile);
	}
    }

    cpuid(0, &eax,&ebx,&ecx,&edx);
    maxi = eax;

    if(maxi >= 1){
        cpuid(1, &eax,&ebx,&ecx,&edx);
	stepping = eax & 0xf;
        model = (eax >> 4) & 0xf;
        family = (eax >> 8) & 0xf;
        reserved = eax >> 12;

	if (open_log_file(&logfile) ==TRUE) {
	    fprintf (logfile, "\tStepping : %d Family : %d Model : %d [",stepping,family,model);

	    switch(family) {
	    case 4:
		fprintf(logfile, "486");
		break;
	    case 5:
		fprintf(logfile, "586/K6");
    		break;
    	    }

	    fprintf(logfile, "]\n\n");
	    close_log_file(&logfile);
	}
    }
}
