/*
  Determine CPU Vendor & Stepping.
*/

void Decode_Intel(void);


void Decode_Intel(void)
{
  unsigned int maxi;
  unsigned int eax,ebx,ecx,edx;
  int stepping,model,family,type,reserved;

  cpuid(0, &eax,&ebx,&ecx,&edx);
  maxi = eax;

  if(maxi >= 1){
    /* Family/model/type etc */
    cpuid(1, &eax,&ebx,&ecx,&edx);
    stepping = eax & 0xf;
    model = (eax >> 4) & 0xf;
    family = (eax >> 8) & 0xf;
    type = (eax >> 12) & 0x3;
    reserved = eax >> 14;

    printf("Family: %d Model: %d Type %d [",family,model,type);
    switch(family){
    case 3:
      printf("i386 ");
      switch(model){
      }
      break;
    case 4:
      printf("i486 ");
      switch(model){
      case 0:
      case 1:
	printf("DX");
	break;
      case 2:
	printf("SX");
	break;
      case 3:
	printf("487/DX2");
	break;
      case 4:
	printf("SL");
	break;
      case 5:
	printf("SX2");
	break;
      case 7:
	printf("write-back enhanced DX2");
	break;
      case 8:
	printf("DX4");
	break;
      }
      break;
    case 5:
      printf("Pentium ");
      switch(model){
      case 1:
	printf("60/66");
	break;
      case 2:
	printf("75-200");
	break;
      case 3:
	printf("for 486 system");
	break;
      case 4:
	printf("MMX");
	break;
      }
      break;
    case 6:
      printf("Pentium Pro; ");
      switch(model){
      case 1:
	printf("Pentium Pro;");
	break;
      case 3:
	printf("Pentium II Model 3;");
	break;
      case 5:
	printf("Pentium II Model 5/Xeon/Celeron;");
	break;
      case 6:
	printf("Celeron;");
	break;
      case 7:
	printf("Pentium III/Pentium III Xeon;");
	break;
      }
      break;
    }
    switch(type){
    case 0:
      printf(" Original OEM");
      break;
    case 1:
      printf(" Overdrive");
      break;
    case 2:
      printf(" Dual-capable");
      break;
    case 3:
      printf(" Reserved");
      break;
    }
    printf("]\n");
    printf("Stepping: %d\n",stepping);
  }
}
