/*	$Id: powertweak.c,v 0.1.0 1999/6/27 18:04:23 dj Exp $
 *
 *	Linux PCI Utilities -- Tune PCI devices.
 *
 *	Copyright (c) 1997--1999 Dave Jones <dave@powertweak.com>
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 *	*NB* No code or data-tables from Powertweak may be used in any profit
 *	     making application (regardless of OS) without express permission.
 *
 * TS: 4
 */


void corrupt_configfile(char expected, char got);
void SkipComment(char **fptr);
char GetNextTag(char **fptr);
void FindTag(char findchar, char **fptr);
void decode_special(char **fptr);


/*
 corrupt_configfile()
 This function never returns.
 As the function name suggest, If we get here,
 something is seriously bad with the config file.
 Either that, or we got a bug somewhere.
 */
void corrupt_configfile(char expected, char got)
{
    printf("Parse error!\nExpected \"%c\", got \"%c\"\n", expected, got);
    exit(EXIT_FAILURE);
}



void SkipComment(char **fptr)
{
    ++*fptr;
    while(**fptr != '\n') {	/* Skip to EOL.*/
	(*fptr)++;
    }
    if (**fptr =='#')
	SkipComment(fptr);
}



/*
 GetNextTag()
 This seeks forward for a :
 When it finds one, it returns the character that was found.
 */
char GetNextTag(char **fptr)
{
re_enter:
    while ((**fptr !=':') && (**fptr !='#')) {
	(*fptr)++;
    }

    switch (**fptr) {

	case '#':	SkipComment(fptr);
			goto re_enter;

	case ':':	(*fptr)--;
    }
    return (**fptr);

}



/*
 FindTag. This will look for D: V: etc...
 If it doesn't find the tag that we are expecting,
 this function never returns, the program is exited
 immediately, as it mean the config file is damaged.
 */

void FindTag(char findchar, char **fptr)
{

re_enter:
    while ((**fptr != findchar) && (**fptr !='#')) {
	(*fptr)++;
    }

    switch (**fptr) {

    case '#':		SkipComment(fptr);
			goto re_enter;

    case '!' :		(*fptr)++;
			if (**fptr=='.')
			    corrupt_configfile('.', **fptr);
			decode_special(fptr);
			goto re_enter;
			
    case ' ' :    
    case '\t':
    case '\n':		(*fptr)++;
			goto re_enter;

    /* Default gets executed if we hit the char we wanted. */
    default :		(*fptr)++;
	    		if (**fptr != ':') {
			    printf("Whilst looking for %c I found %c\n", findchar, **fptr);
			    corrupt_configfile(':', **fptr);
			}
			(*fptr)++;
			break;
    }
}


void decode_special(char **fptr)
{
    const char if_string[]="if ";
    const char fi_string[]="fi";

    if (strncasecmp(*fptr, if_string, 3)==0) {
	decode_if(fptr);
	goto out;
    }

    if (strncasecmp(*fptr, fi_string, 2)==0) {
	(*fptr)+=2;
	goto out;
    }
out:
}
