/*	$Id: powertweak.c,v 0.1.0 1999/6/27 18:04:23 dj Exp $
 *
 *	Linux PCI Utilities -- Tune PCI devices.
 *
 *	Copyright (c) 1997--1999 Dave Jones <dave@powertweak.com>
 *	contains some code by Martin Mares <mj@atrey.karlin.mff.cuni.cz>
 *
 *	Can be freely distributed and used under the terms of the GNU GPL.
 *	*NB* No code or data-tables from Powertweak may be used in any profit
 *	     making application (regardless of OS) without express permission.
 *
 * TS: 4
 */

void poke( unsigned int poke_reg, char *reasonptr, word current_value, word poke_value, char *choiceptr, unsigned int c_offset);

void poke( unsigned int poke_reg, char *reasonptr, word current_value, word poke_value, char *choiceptr, unsigned int c_offset)
{
    char reason[80]="";
    char choice[80]="";

    FILE *logfile=0;

    unsigned int i;


    /* Copy the reason to buffer. */
    i=0;
    while (*reasonptr!='\n') {
	reason[i++]=*reasonptr++;
    }
    reason[i]='\0';



    /* Handle the C: choices. */
    i=0;
    /* First we check for a range (specified as C:*
       If this is found, we copy the poke value into the buffer. */
    if (*choiceptr=='*') {
	if (poke_value<10) {
	    choice[i++]=poke_value+'0';
	} else {
	    choice[i++]=(poke_value>>4)+'0';
	    choice[i++]=(poke_value&0x0f)+'0';
	}
    } else {
	/* Now, we must skip forward to the right option in the C: string */
	if (c_offset!=0) {
	    for (i=0;i<c_offset;i++) {
		while (*choiceptr!=',') {
		    choiceptr++;
		}
	    }
	    /* Skip the comma. (only there if we choice option>0)	*/
	    if(*choiceptr==',')
		choiceptr++;
	}
	/* Copy the selected choice to buffer. */
	i=0;
	while (*choiceptr!=',' && *choiceptr!='\n' && *choiceptr!='#') {
	    choice[i++]=*choiceptr++;
	}
    }
    choice[i++]='\0';



    /* Do the poking. */
    if (open_log_file(&logfile)==TRUE) {

	if (current_value == poke_value) {
	    fprintf(logfile, "\tSKIP: %s: %s [0x%x,0x%x]\n", reason, choice, poke_reg, poke_value);
	} else {
	    fprintf(logfile, "\tPOKE: %s: %s [0x%x,0x%x] -> [0x%x,0x%x]\n",
		reason, choice,
	        poke_reg, current_value,
		poke_reg, poke_value);
	}
	close_log_file(&logfile);
    }

    if (current_value != poke_value)
	pci_write_byte (dev, poke_reg, poke_value);
}
